(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('ibm-wch-sdk-ng'), require('rxjs/Observable'), require('@angular/core'), require('rxjs/operators/switchMap'), require('rxjs/operators/map'), require('rxjs/operators/pluck'), require('rxjs/operators/tap'), require('rxjs/operators/shareReplay'), require('rxjs/operators/takeUntil'), require('@angular/common')) :
	typeof define === 'function' && define.amd ? define('ibm-wch-sdk-ng-pzn', ['exports', 'ibm-wch-sdk-ng', 'rxjs/Observable', '@angular/core', 'rxjs/operators/switchMap', 'rxjs/operators/map', 'rxjs/operators/pluck', 'rxjs/operators/tap', 'rxjs/operators/shareReplay', 'rxjs/operators/takeUntil', '@angular/common'], factory) :
	(factory((global['ibm-wch-sdk-ng-pzn'] = {}),global['ibm-wch-sdk-ng'],global.Rx,global.ng.core,global.Rx.Observable.prototype,global.Rx.Observable.prototype,global.Rx.Observable.prototype,global.Rx.Observable.prototype,global.Rx.Observable.prototype,global.Rx.Observable.prototype,global.ng.common));
}(this, (function (exports,ibmWchSdkNg,Observable,core,switchMap,map,pluck,tap,shareReplay,takeUntil,common) { 'use strict';

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0
THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.
See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
/* global Reflect, Promise */
var extendStatics = function(d, b) {
    extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return extendStatics(d, b);
};
function __extends(d, b) {
    extendStatics(d, b);
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}


function __decorate(decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
}

function __metadata(metadataKey, metadataValue) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
}

var AbstractInteractionpointComponent = /** @class */ (function (_super) {
    __extends(AbstractInteractionpointComponent, _super);
    function AbstractInteractionpointComponent() {
        return _super.call(this) || this;
    }
    return AbstractInteractionpointComponent;
}(ibmWchSdkNg.AbstractRenderingComponent));
__decorate([
    ibmWchSdkNg.RenderingContextBinding('text.name'),
    __metadata("design:type", Observable.Observable)
], AbstractInteractionpointComponent.prototype, "onName", void 0);
__decorate([
    ibmWchSdkNg.RenderingContextBinding(),
    __metadata("design:type", String)
], AbstractInteractionpointComponent.prototype, "name", void 0);
var BACKEND_SERVICE_TOKEN = new core.InjectionToken('BackendService');
var AbstractBackendService = /** @class */ (function () {
    function AbstractBackendService() {
    }
    return AbstractBackendService;
}());
AbstractBackendService.decorators = [
    { type: core.Injectable },
];
var LOGGER = 'TypeInteractionpointComponent';
var TypeInteractionpointComponent = /** @class */ (function (_super) {
    __extends(TypeInteractionpointComponent, _super);
    function TypeInteractionpointComponent(aInjector) {
        var _this = _super.call(this) || this;
        var that = _this;
        var onDestroy = that.onOnDestroy;
        var backendService = aInjector.get(BACKEND_SERVICE_TOKEN);
        var onInteractionpointId = that.onName.pipe(shareReplay.shareReplay(1), tap.tap(function (id) { return console.log(LOGGER, 'Interactionpoint: ', id); }));
        var onOffer = onInteractionpointId.pipe(switchMap.switchMap(function (id) { return backendService.getOffers(id); }), shareReplay.shareReplay(1), takeUntil.takeUntil(onDestroy));
        function queryBuilder(offer) {
            var fields = [];
            fields = offer['id'] && offer['id'] !== '' ?
                ["id:\"" + ibmWchSdkNg.luceneEscapeTerm(offer['id']) + "\""]
                :
                    Object.keys(offer)
                        .filter(function (key) { return ['sort', 'display', 'rows', 'id'].indexOf(key) === -1; })
                        .filter(function (key) { return offer[key] && (typeof offer[key]) === 'string' && offer[key] !== ''; })
                        .map(function (key) {
                        var field;
                        var query;
                        field = key;
                        query = ibmWchSdkNg.luceneEscapeTerm(offer[key]);
                        return field + ":\"" + query + "\"";
                    });
            return { 'q': fields.join(' AND '), 'sort': offer['sort'], 'rows': offer['rows'] };
        }
        that.onDisplay = onOffer.pipe(pluck.pluck('display'));
        that.onQuery = onOffer.pipe(map.map(queryBuilder), tap.tap(function (q) { return console.log('Lucene: ', JSON.stringify(q)); }));
        return _this;
    }
    return TypeInteractionpointComponent;
}(AbstractInteractionpointComponent));
TypeInteractionpointComponent.ctorParameters = function () { return [
    { type: core.Injector, decorators: [{ type: core.Inject, args: [core.Injector,] },] },
]; };
TypeInteractionpointComponent.propDecorators = {
    "onQuery": [{ type: core.Output },],
    "onDisplay": [{ type: core.Output },],
};
exports.InteractionpointLayoutComponent = /** @class */ (function (_super) {
    __extends(InteractionpointLayoutComponent, _super);
    function InteractionpointLayoutComponent(aInjector) {
        return _super.call(this, aInjector) || this;
    }
    return InteractionpointLayoutComponent;
}(TypeInteractionpointComponent));
exports.InteractionpointLayoutComponent.decorators = [
    { type: core.Component, args: [{
                selector: 'app-interactionpoint-layout-component',
                template: "<wch-contentquery *ngIf=\"onDisplay | async\" [query]=\"onQuery | async\" #id>\n    <wch-contentref *ngFor=\"let rc of id.onRenderingContexts | async;trackBy: trackByComponentId\" [renderingContext]=\"rc\"></wch-contentref>\n</wch-contentquery> \n",
                styles: [""],
                preserveWhitespaces: false
            },] },
];
exports.InteractionpointLayoutComponent.ctorParameters = function () { return [
    { type: core.Injector, decorators: [{ type: core.Inject, args: [core.Injector,] },] },
]; };
exports.InteractionpointLayoutComponent = __decorate([
    ibmWchSdkNg.LayoutComponent({
        selector: 'interactionpoint'
    }),
    __metadata("design:paramtypes", [core.Injector])
], exports.InteractionpointLayoutComponent);
var WchNgPznModule = /** @class */ (function () {
    function WchNgPznModule(parentModule) {
    }
    WchNgPznModule.forRoot = function () {
        return {
            ngModule: WchNgPznModule,
            providers: []
        };
    };
    return WchNgPznModule;
}());
WchNgPznModule.decorators = [
    { type: core.NgModule, args: [{
                imports: [
                    common.CommonModule,
                    ibmWchSdkNg.WchNgModule
                ],
                declarations: [
                    exports.InteractionpointLayoutComponent
                ],
                providers: [],
                exports: [
                    exports.InteractionpointLayoutComponent
                ],
                entryComponents: [
                    exports.InteractionpointLayoutComponent
                ]
            },] },
];
WchNgPznModule.ctorParameters = function () { return [
    { type: WchNgPznModule, decorators: [{ type: core.Optional }, { type: core.SkipSelf },] },
]; };
var ANALYTICS_SERVICE_TOKEN = new core.InjectionToken('AnalyticsService');
var AbstractAnalyticsService = /** @class */ (function () {
    function AbstractAnalyticsService() {
    }
    return AbstractAnalyticsService;
}());
AbstractAnalyticsService.decorators = [
    { type: core.Injectable },
];

exports.ɵc = ibmWchSdkNg.AbstractRenderingComponent;
exports.ɵe = ibmWchSdkNg.LayoutComponent;
exports.ɵd = ibmWchSdkNg.RenderingContextBinding;
exports.ɵa = ibmWchSdkNg.WchNgModule;
exports.WchNgPznModule = WchNgPznModule;
exports.BACKEND_SERVICE_TOKEN = BACKEND_SERVICE_TOKEN;
exports.AbstractBackendService = AbstractBackendService;
exports.ANALYTICS_SERVICE_TOKEN = ANALYTICS_SERVICE_TOKEN;
exports.AbstractAnalyticsService = AbstractAnalyticsService;
exports.TypeInteractionpointComponent = TypeInteractionpointComponent;
exports.ɵb = AbstractInteractionpointComponent;

Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ibm-wch-sdk-ng-pzn.umd.js.map
