import { RenderingContextBinding, AbstractRenderingComponent, luceneEscapeTerm, LayoutComponent, WchNgModule } from 'ibm-wch-sdk-ng';
export { AbstractRenderingComponent as ɵc, LayoutComponent as ɵe, RenderingContextBinding as ɵd, WchNgModule as ɵa } from 'ibm-wch-sdk-ng';
import { __decorate, __metadata } from 'tslib';
import { Observable } from 'rxjs/Observable';
import { InjectionToken, Injectable, Output, Inject, Injector, Component, NgModule, Optional, SkipSelf } from '@angular/core';
import { switchMap } from 'rxjs/operators/switchMap';
import { map } from 'rxjs/operators/map';
import { pluck } from 'rxjs/operators/pluck';
import { tap } from 'rxjs/operators/tap';
import { shareReplay } from 'rxjs/operators/shareReplay';
import { takeUntil } from 'rxjs/operators/takeUntil';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @abstract
 */
class AbstractInteractionpointComponent extends AbstractRenderingComponent {
    constructor() {
        super();
    }
}
__decorate([
    RenderingContextBinding('text.name'),
    __metadata("design:type", Observable)
], AbstractInteractionpointComponent.prototype, "onName", void 0);
__decorate([
    RenderingContextBinding(),
    __metadata("design:type", String)
], AbstractInteractionpointComponent.prototype, "name", void 0);

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/* Copyright IBM Corp. 2017
See readme for explanations*/
const BACKEND_SERVICE_TOKEN = new InjectionToken('BackendService');
/**
 * @abstract
 */
class AbstractBackendService {
}
AbstractBackendService.decorators = [
    { type: Injectable },
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
const LOGGER = 'TypeInteractionpointComponent';
class TypeInteractionpointComponent extends AbstractInteractionpointComponent {
    /**
     * @param {?} aInjector
     */
    constructor(aInjector) {
        super();
        const /** @type {?} */ that = this;
        // the cancel hooks
        const /** @type {?} */ onDestroy = that.onOnDestroy;
        // inject the backend service for the marketing software
        const /** @type {?} */ backendService = aInjector.get(BACKEND_SERVICE_TOKEN);
        // interactionpoint Id
        const /** @type {?} */ onInteractionpointId = that.onName.pipe(shareReplay(1), tap(id => console.log(LOGGER, 'Interactionpoint: ', id)));
        // get offers for interactionpoint
        const /** @type {?} */ onOffer = onInteractionpointId.pipe(switchMap(id => backendService.getOffers(id)), shareReplay(1), takeUntil(onDestroy));
        /**
         * @param {?} offer
         * @return {?}
         */
        function queryBuilder(offer) {
            let /** @type {?} */ fields = [];
            // create query as array
            fields = offer['id'] && offer['id'] !== '' ?
                [`id:"${luceneEscapeTerm(offer['id'])}"`]
                :
                    Object.keys(offer)
                        .filter(key => ['sort', 'display', 'rows', 'id'].indexOf(key) === -1) // filter relevant parameters for query
                        .filter(key => offer[key] && (typeof offer[key]) === 'string' && offer[key] !== '') // filter undefined values
                        .map((key) => {
                        let /** @type {?} */ field;
                        let /** @type {?} */ query;
                        field = key;
                        query = luceneEscapeTerm(offer[key]);
                        return `${field}:"${query}"`;
                    });
            // create Query object
            return { 'q': fields.join(' AND '), 'sort': offer['sort'], 'rows': offer['rows'] };
        }
        // output if component should be displayed
        that.onDisplay = onOffer.pipe(pluck('display')); // offer['display]: boolean
        // output query
        that.onQuery = onOffer.pipe(map(queryBuilder), tap(q => console.log('Lucene: ', JSON.stringify(q))));
    }
}
/** @nocollapse */
TypeInteractionpointComponent.ctorParameters = () => [
    { type: Injector, decorators: [{ type: Inject, args: [Injector,] },] },
];
TypeInteractionpointComponent.propDecorators = {
    "onQuery": [{ type: Output },],
    "onDisplay": [{ type: Output },],
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
let InteractionpointLayoutComponent = class InteractionpointLayoutComponent extends TypeInteractionpointComponent {
    /**
     * @param {?} aInjector
     */
    constructor(aInjector) {
        super(aInjector);
        /*
                 * TODO initialize your custom fields here, note that
                 * you can refer to the values bound via @RenderingContextBinding from
                 * your super class.
                 *
                 * Make sure to call 'this.safeSubscribe' if you plan to subscribe to observables
                 */
    }
};
InteractionpointLayoutComponent.decorators = [
    { type: Component, args: [{
                selector: 'app-interactionpoint-layout-component',
                template: `<wch-contentquery *ngIf="onDisplay | async" [query]="onQuery | async" #id>
    <wch-contentref *ngFor="let rc of id.onRenderingContexts | async;trackBy: trackByComponentId" [renderingContext]="rc"></wch-contentref>
</wch-contentquery> 
`,
                styles: [``],
                preserveWhitespaces: false
            },] },
];
/** @nocollapse */
InteractionpointLayoutComponent.ctorParameters = () => [
    { type: Injector, decorators: [{ type: Inject, args: [Injector,] },] },
];
InteractionpointLayoutComponent = __decorate([
    LayoutComponent({
        selector: 'interactionpoint'
    }),
    __metadata("design:paramtypes", [Injector])
], InteractionpointLayoutComponent);

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
class WchNgPznModule {
    /**
     * @param {?} parentModule
     */
    constructor(parentModule) {
    }
    /**
     * @return {?}
     */
    static forRoot() {
        // returns the configured module
        return {
            ngModule: WchNgPznModule,
            providers: []
        };
    }
}
WchNgPznModule.decorators = [
    { type: NgModule, args: [{
                imports: [
                    CommonModule,
                    WchNgModule
                ],
                declarations: [
                    InteractionpointLayoutComponent
                ],
                providers: [],
                exports: [
                    InteractionpointLayoutComponent
                ],
                entryComponents: [
                    InteractionpointLayoutComponent
                ]
            },] },
];
/** @nocollapse */
WchNgPznModule.ctorParameters = () => [
    { type: WchNgPznModule, decorators: [{ type: Optional }, { type: SkipSelf },] },
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/* Copyright IBM Corp. 2017
See readme for explanations*/
const ANALYTICS_SERVICE_TOKEN = new InjectionToken('AnalyticsService');
/**
 * @abstract
 */
class AbstractAnalyticsService {
}
AbstractAnalyticsService.decorators = [
    { type: Injectable },
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * Generated bundle index. Do not edit.
 */

export { WchNgPznModule, BACKEND_SERVICE_TOKEN, AbstractBackendService, ANALYTICS_SERVICE_TOKEN, AbstractAnalyticsService, TypeInteractionpointComponent, InteractionpointLayoutComponent, AbstractInteractionpointComponent as ɵb };
//# sourceMappingURL=ibm-wch-sdk-ng-pzn.js.map
