import { __decorate, __metadata, __extends } from 'tslib';
import { RenderingContextBinding, AbstractRenderingComponent, luceneEscapeTerm, LayoutComponent, WchNgModule } from 'ibm-wch-sdk-ng';
export { AbstractRenderingComponent as ɵc, LayoutComponent as ɵe, RenderingContextBinding as ɵd, WchNgModule as ɵa } from 'ibm-wch-sdk-ng';
import { Observable } from 'rxjs/Observable';
import { InjectionToken, Injectable, Output, Inject, Injector, Component, NgModule, Optional, SkipSelf } from '@angular/core';
import { switchMap } from 'rxjs/operators/switchMap';
import { map } from 'rxjs/operators/map';
import { pluck } from 'rxjs/operators/pluck';
import { tap } from 'rxjs/operators/tap';
import { shareReplay } from 'rxjs/operators/shareReplay';
import { takeUntil } from 'rxjs/operators/takeUntil';
import { CommonModule } from '@angular/common';

var AbstractInteractionpointComponent = /** @class */ (function (_super) {
    __extends(AbstractInteractionpointComponent, _super);
    function AbstractInteractionpointComponent() {
        return _super.call(this) || this;
    }
    return AbstractInteractionpointComponent;
}(AbstractRenderingComponent));
__decorate([
    RenderingContextBinding('text.name'),
    __metadata("design:type", Observable)
], AbstractInteractionpointComponent.prototype, "onName", void 0);
__decorate([
    RenderingContextBinding(),
    __metadata("design:type", String)
], AbstractInteractionpointComponent.prototype, "name", void 0);
var BACKEND_SERVICE_TOKEN = new InjectionToken('BackendService');
var AbstractBackendService = /** @class */ (function () {
    function AbstractBackendService() {
    }
    return AbstractBackendService;
}());
AbstractBackendService.decorators = [
    { type: Injectable },
];
var LOGGER = 'TypeInteractionpointComponent';
var TypeInteractionpointComponent = /** @class */ (function (_super) {
    __extends(TypeInteractionpointComponent, _super);
    function TypeInteractionpointComponent(aInjector) {
        var _this = _super.call(this) || this;
        var that = _this;
        var onDestroy = that.onOnDestroy;
        var backendService = aInjector.get(BACKEND_SERVICE_TOKEN);
        var onInteractionpointId = that.onName.pipe(shareReplay(1), tap(function (id) { return console.log(LOGGER, 'Interactionpoint: ', id); }));
        var onOffer = onInteractionpointId.pipe(switchMap(function (id) { return backendService.getOffers(id); }), shareReplay(1), takeUntil(onDestroy));
        function queryBuilder(offer) {
            var fields = [];
            fields = offer['id'] && offer['id'] !== '' ?
                ["id:\"" + luceneEscapeTerm(offer['id']) + "\""]
                :
                    Object.keys(offer)
                        .filter(function (key) { return ['sort', 'display', 'rows', 'id'].indexOf(key) === -1; })
                        .filter(function (key) { return offer[key] && (typeof offer[key]) === 'string' && offer[key] !== ''; })
                        .map(function (key) {
                        var field;
                        var query;
                        field = key;
                        query = luceneEscapeTerm(offer[key]);
                        return field + ":\"" + query + "\"";
                    });
            return { 'q': fields.join(' AND '), 'sort': offer['sort'], 'rows': offer['rows'] };
        }
        that.onDisplay = onOffer.pipe(pluck('display'));
        that.onQuery = onOffer.pipe(map(queryBuilder), tap(function (q) { return console.log('Lucene: ', JSON.stringify(q)); }));
        return _this;
    }
    return TypeInteractionpointComponent;
}(AbstractInteractionpointComponent));
TypeInteractionpointComponent.ctorParameters = function () { return [
    { type: Injector, decorators: [{ type: Inject, args: [Injector,] },] },
]; };
TypeInteractionpointComponent.propDecorators = {
    "onQuery": [{ type: Output },],
    "onDisplay": [{ type: Output },],
};
var InteractionpointLayoutComponent = /** @class */ (function (_super) {
    __extends(InteractionpointLayoutComponent, _super);
    function InteractionpointLayoutComponent(aInjector) {
        return _super.call(this, aInjector) || this;
    }
    return InteractionpointLayoutComponent;
}(TypeInteractionpointComponent));
InteractionpointLayoutComponent.decorators = [
    { type: Component, args: [{
                selector: 'app-interactionpoint-layout-component',
                template: "<wch-contentquery *ngIf=\"onDisplay | async\" [query]=\"onQuery | async\" #id>\n    <wch-contentref *ngFor=\"let rc of id.onRenderingContexts | async;trackBy: trackByComponentId\" [renderingContext]=\"rc\"></wch-contentref>\n</wch-contentquery> \n",
                styles: [""],
                preserveWhitespaces: false
            },] },
];
InteractionpointLayoutComponent.ctorParameters = function () { return [
    { type: Injector, decorators: [{ type: Inject, args: [Injector,] },] },
]; };
InteractionpointLayoutComponent = __decorate([
    LayoutComponent({
        selector: 'interactionpoint'
    }),
    __metadata("design:paramtypes", [Injector])
], InteractionpointLayoutComponent);
var WchNgPznModule = /** @class */ (function () {
    function WchNgPznModule(parentModule) {
    }
    WchNgPznModule.forRoot = function () {
        return {
            ngModule: WchNgPznModule,
            providers: []
        };
    };
    return WchNgPznModule;
}());
WchNgPznModule.decorators = [
    { type: NgModule, args: [{
                imports: [
                    CommonModule,
                    WchNgModule
                ],
                declarations: [
                    InteractionpointLayoutComponent
                ],
                providers: [],
                exports: [
                    InteractionpointLayoutComponent
                ],
                entryComponents: [
                    InteractionpointLayoutComponent
                ]
            },] },
];
WchNgPznModule.ctorParameters = function () { return [
    { type: WchNgPznModule, decorators: [{ type: Optional }, { type: SkipSelf },] },
]; };
var ANALYTICS_SERVICE_TOKEN = new InjectionToken('AnalyticsService');
var AbstractAnalyticsService = /** @class */ (function () {
    function AbstractAnalyticsService() {
    }
    return AbstractAnalyticsService;
}());
AbstractAnalyticsService.decorators = [
    { type: Injectable },
];

export { WchNgPznModule, BACKEND_SERVICE_TOKEN, AbstractBackendService, ANALYTICS_SERVICE_TOKEN, AbstractAnalyticsService, TypeInteractionpointComponent, InteractionpointLayoutComponent, AbstractInteractionpointComponent as ɵb };
//# sourceMappingURL=ibm-wch-sdk-ng-pzn.js.map
